<template>
  <!-- 管理 - 财务审核 - 发票 -->
  <mtp-table-scroll>
    <template #header>
      <Filter @search="updateColumn"></Filter>
    </template>
    <template #default="{ scroll }">
      <a-table :columns="columns" class="srcollYTable" :pagination="false" :expandedRowKeys="expandedRowKeys" :customRow="Rowclick" :rowKey="(record,index)=>index" :scroll="scroll" :data-source="tableList">
        <!-- 额外的展开行 -->
        <template #expandedRowRender="{ record }">
          <mtp-table-button class="btn-list-sticky" :buttons="handlePermissionBtn(buttons, record)" :record="record" @click="openComponent" />
        </template>
        <!-- 现货合同类型 -->
        <template #contracttype="{ text }">
          <a>{{ getContractTypeName(text) }}</a>
        </template>
        <!-- 发票类型-->
        <template #invoicetype="{ text }">
          <a>{{ getReceiptName(text) }}</a>
        </template>
        <!-- 状态 -->
        <template #applystatus="{ text }">
          <a>{{ getApplyStatusName(text) }}</a>
        </template>
        <!-- 点价类型 -->
        <template #pricetype="{ text }">
          <a>{{ getPriceTypeName(text) }}</a>
        </template>
        <!-- 对手方 -->
        <template #buyusernameOrsellusername="{ record }">
          <a>{{ record.contracttype === 1 ? record.sellusername : record.buyusername }}</a>
        </template>
      </a-table>
    </template>
  </mtp-table-scroll>
  <!-- 右键 -->
  <contextMenu :contextMenu="contextMenu" @cancel="closeContext" :list="handlePermissionBtn(buttons, selectedRow)"> </contextMenu>
  <component :is="componentId" v-if="componentId" :selectedRow="selectedRow" @cancel="closeComponent"></component>
</template>

<script lang="ts">
import MtpTableScroll from '@/common/components/tableScroll/index.vue';
import { queryTableList, MtpTableButton, contextMenu, defineAsyncComponent, defineComponent, handleComposeTable, ComposeTableParam } from '@/common/export/commonTable';
import { Filter } from '../../components';
import { Column, ColumnType } from '@/common/setup/table';
import { getContractTypeName, getApplyStatusName, getReceiptName, getPriceTypeName } from '@/common/constants/enumsName';
import { BtnListType } from '@/common/components/btnList/interface';
import { getTableButton } from '@/common/setup/table/button';
import { QueryBusinessFp } from '@/services/go/ermcp/finance-review';
import { QryBussinessFpRsp } from '@/services/go/ermcp/finance-review/interface';
import { useRoute } from 'vue-router';

export default defineComponent({
  name: 'finance_review_invoice',
  components: {
    MtpTableScroll,
    contextMenu,
    Filter,
    MtpTableButton,
    detail: defineAsyncComponent(() => import('../../components/invoiceDetail/index.vue')),
    check: defineAsyncComponent(() => import('../../components/invoiceAudit/index.vue')),
    cancel: defineAsyncComponent(() => import('../../components/invoiceCancel/index.vue')),
  },
  setup() {
    const { name: routeName } = useRoute();
    // 权限按钮
    const buttons = getTableButton();

    // 表格列表数据
    const { loading, tableList, queryTable } = queryTableList<QryBussinessFpRsp>();

    // 获取列表数据
    const queryTableAction = () => {
      switch (routeName) {
        case 'invoice_checkpending':
          queryTable(QueryBusinessFp, { applystatus: '1' });
          break;
        case 'invoice_performance':
          queryTable(QueryBusinessFp, { applystatus: '2,3' });
          break;
      }
    };

    const filtrFn = (e: Column, item: ColumnType, filtered: any) => {
      if (e.columnfield === 'buyusernameOrsellusername') {
        item.onFilter = (value: string, record: QryBussinessFpRsp) => {
          const { contracttype, buyusername, sellusername } = record;
          if (contracttype === 1) {
            // 采购
            return sellusername.includes(value);
          } else {
            return buyusername.includes(value);
          }
        };
        item.filteredValue = filtered.buyusernameOrsellusername || null;
      }
    };

    // 获取表头名称
    const getTableName = () => {
      switch (routeName) {
        // 业务审核-发票
        case 'invoice_checkpending':
          return 'table_pcweb_fincial_aduit_fp';
        // 业务审核-发票-已审核
        case 'invoice_performance':
          return 'table_pcweb_fincial_aduit_yfp';
      }
    };

    // 表格通用逻辑
    const param: ComposeTableParam = {
      queryFn: queryTableAction,
      tableName: getTableName(),
      tableFilterCB: filtrFn,
    };

    function handlePermissionBtn(btnList: BtnListType[], item: QryBussinessFpRsp) {
      if (item) {
        const { applystatus } = item;
        if (applystatus === 1) {
          return btnList;
        } else {
          return btnList.filter((e) => e.code === 'detail');
        }
      } else {
        return [];
      }
    }

    return {
      ...handleComposeTable<QryBussinessFpRsp>(param),
      loading,
      tableList,
      handlePermissionBtn,
      getContractTypeName,
      getReceiptName,
      getApplyStatusName,
      getPriceTypeName,
      buttons,
    };
  },
});
</script>
<style scoped>
.attachurl {
    white-space: nowrap;
}
</style>